package xyz.lychee.lagfixer.libs.examination;

import xyz.lychee.lagfixer.libs.annotations.NotNull;
import xyz.lychee.lagfixer.libs.annotations.Nullable;

public abstract class ExaminableProperty {
   private ExaminableProperty() {
   }

   public abstract @NotNull String name();

   public abstract <R> @NotNull R examine(final @NotNull Examiner<? extends R> examiner);

   public String toString() {
      return "ExaminableProperty{" + this.name() + "}";
   }

   public static @NotNull ExaminableProperty of(final @NotNull String name, final @Nullable Object value) {
      return new ExaminableProperty() {
         public @NotNull String name() {
            return name;
         }

         public <R> @NotNull R examine(final @NotNull Examiner<? extends R> examiner) {
            return examiner.examine(value);
         }
      };
   }

   public static @NotNull ExaminableProperty of(final @NotNull String name, final @Nullable String value) {
      return new ExaminableProperty() {
         public @NotNull String name() {
            return name;
         }

         public <R> @NotNull R examine(final @NotNull Examiner<? extends R> examiner) {
            return examiner.examine(value);
         }
      };
   }

   public static @NotNull ExaminableProperty of(final @NotNull String name, final boolean value) {
      return new ExaminableProperty() {
         public @NotNull String name() {
            return name;
         }

         public <R> @NotNull R examine(final @NotNull Examiner<? extends R> examiner) {
            return examiner.examine(value);
         }
      };
   }

   public static @NotNull ExaminableProperty of(final @NotNull String name, final boolean[] value) {
      return new ExaminableProperty() {
         public @NotNull String name() {
            return name;
         }

         public <R> @NotNull R examine(final @NotNull Examiner<? extends R> examiner) {
            return examiner.examine(value);
         }
      };
   }

   public static @NotNull ExaminableProperty of(final @NotNull String name, final byte value) {
      return new ExaminableProperty() {
         public @NotNull String name() {
            return name;
         }

         public <R> @NotNull R examine(final @NotNull Examiner<? extends R> examiner) {
            return examiner.examine(value);
         }
      };
   }

   public static @NotNull ExaminableProperty of(final @NotNull String name, final byte[] value) {
      return new ExaminableProperty() {
         public @NotNull String name() {
            return name;
         }

         public <R> @NotNull R examine(final @NotNull Examiner<? extends R> examiner) {
            return examiner.examine(value);
         }
      };
   }

   public static @NotNull ExaminableProperty of(final @NotNull String name, final char value) {
      return new ExaminableProperty() {
         public @NotNull String name() {
            return name;
         }

         public <R> @NotNull R examine(final @NotNull Examiner<? extends R> examiner) {
            return examiner.examine(value);
         }
      };
   }

   public static @NotNull ExaminableProperty of(final @NotNull String name, final char[] value) {
      return new ExaminableProperty() {
         public @NotNull String name() {
            return name;
         }

         public <R> @NotNull R examine(final @NotNull Examiner<? extends R> examiner) {
            return examiner.examine(value);
         }
      };
   }

   public static @NotNull ExaminableProperty of(final @NotNull String name, final double value) {
      return new ExaminableProperty() {
         public @NotNull String name() {
            return name;
         }

         public <R> @NotNull R examine(final @NotNull Examiner<? extends R> examiner) {
            return examiner.examine(value);
         }
      };
   }

   public static @NotNull ExaminableProperty of(final @NotNull String name, final double[] value) {
      return new ExaminableProperty() {
         public @NotNull String name() {
            return name;
         }

         public <R> @NotNull R examine(final @NotNull Examiner<? extends R> examiner) {
            return examiner.examine(value);
         }
      };
   }

   public static @NotNull ExaminableProperty of(final @NotNull String name, final float value) {
      return new ExaminableProperty() {
         public @NotNull String name() {
            return name;
         }

         public <R> @NotNull R examine(final @NotNull Examiner<? extends R> examiner) {
            return examiner.examine(value);
         }
      };
   }

   public static @NotNull ExaminableProperty of(final @NotNull String name, final float[] value) {
      return new ExaminableProperty() {
         public @NotNull String name() {
            return name;
         }

         public <R> @NotNull R examine(final @NotNull Examiner<? extends R> examiner) {
            return examiner.examine(value);
         }
      };
   }

   public static @NotNull ExaminableProperty of(final @NotNull String name, final int value) {
      return new ExaminableProperty() {
         public @NotNull String name() {
            return name;
         }

         public <R> @NotNull R examine(final @NotNull Examiner<? extends R> examiner) {
            return examiner.examine(value);
         }
      };
   }

   public static @NotNull ExaminableProperty of(final @NotNull String name, final int[] value) {
      return new ExaminableProperty() {
         public @NotNull String name() {
            return name;
         }

         public <R> @NotNull R examine(final @NotNull Examiner<? extends R> examiner) {
            return examiner.examine(value);
         }
      };
   }

   public static @NotNull ExaminableProperty of(final @NotNull String name, final long value) {
      return new ExaminableProperty() {
         public @NotNull String name() {
            return name;
         }

         public <R> @NotNull R examine(final @NotNull Examiner<? extends R> examiner) {
            return examiner.examine(value);
         }
      };
   }

   public static @NotNull ExaminableProperty of(final @NotNull String name, final long[] value) {
      return new ExaminableProperty() {
         public @NotNull String name() {
            return name;
         }

         public <R> @NotNull R examine(final @NotNull Examiner<? extends R> examiner) {
            return examiner.examine(value);
         }
      };
   }

   public static @NotNull ExaminableProperty of(final @NotNull String name, final short value) {
      return new ExaminableProperty() {
         public @NotNull String name() {
            return name;
         }

         public <R> @NotNull R examine(final @NotNull Examiner<? extends R> examiner) {
            return examiner.examine(value);
         }
      };
   }

   public static @NotNull ExaminableProperty of(final @NotNull String name, final short[] value) {
      return new ExaminableProperty() {
         public @NotNull String name() {
            return name;
         }

         public <R> @NotNull R examine(final @NotNull Examiner<? extends R> examiner) {
            return examiner.examine(value);
         }
      };
   }

   // $FF: synthetic method
   ExaminableProperty(Object x0) {
      this();
   }
}
